#include <Voice.h>
#define SUM 10 //SUM识别关键词的个数,最大不超过50个
uint8  nAsrStatus=0;
char sRecog[SUM][80] = {"qian jin", "hou tui","zuo zhuan", "you zhuan","ting zhi","chang ge","zan ting bo","ji xu bo","xia yi shou","shang yi shou"};//每个关键词拼音字母个数不超过79个,用户可以自行修改      
int E1 = 5;     //M1 Speed Control
int E2 = 6;     //M2 Speed Control
int M1 = 4;     //M1 Direction Control
int M2 = 7;     //M1 Direction Control

void stop(void)                    //Stop
{
  digitalWrite(E1,0);  
  digitalWrite(E2,0);    
}   
void advance(char a,char b)          //Move forward
{
  analogWrite (E1,a);      //PWM Speed Control
  digitalWrite(M1,HIGH);    
  analogWrite (E2,b);    
  digitalWrite(M2,HIGH);
}  
void back_off (char a,char b)          //Move backward
{
  analogWrite (E1,a);
  digitalWrite(M1,LOW);   
  analogWrite (E2,b);    
  digitalWrite(M2,LOW);
}
void turn_L (char a,char b)             //Turn Left
{
  analogWrite (E1,a);
  digitalWrite(M1,LOW);    
  analogWrite (E2,b);    
  digitalWrite(M2,HIGH);
}
void turn_R (char a,char b)             //Turn Right
{
  analogWrite (E1,a);
  digitalWrite(M1,HIGH);    
  analogWrite (E2,b);    
  digitalWrite(M2,LOW);
}

void finally (unsigned char n)
{
switch(n)  //n为数组中对应关键词的序列号，例如数组sRecog中的第一个关键词为“kai deng”则对应的序列号为0；

	{
	case 0:
		Serial.println( "qian jin");
               Serial.println("\\qian"); 
                advance (255,255);  
		break;
	case 1:
		Serial.println( "hou tui");
                Serial.println("\\hou");
                back_off (255,255); 
		break;
        case 2:
		Serial.println( "zuo zhuan");
                Serial.println("\\zuo");
                turn_L (100,100);    
		break;
        case 3:
		Serial.println( "you zhuan");
                Serial.println("\\you");
                turn_R (100,100);    
		break;
       case 4:
		Serial.println( "ting zhi");
                Serial.println("\\zhi");
                stop();    
		break;
       case 5:
		Serial.println( "chang ge");
                Serial.println("\\bo");  
                Serial.println("\\2");  
		break;
       case 6:
		Serial.println( "zan ting bo");
                Serial.println("\\:p");  
		break;
       case 7:
		Serial.println( "ji xu bo");
                Serial.println("\\:s");    
		break;
       case 8:
		Serial.println( "xia yi shou");
                Serial.println("\\:n");    
		break;
       case 9:
		Serial.println( "shang yi shou");
                Serial.println("\\:u");    
		break;
	default:
	        Serial.println( "error");
                Serial.println( " ");
		break;	
	}
}

void ExtInt0Handler ()
{
  Voice.ProcessInt0();	//芯片送出中断信号				
}
 
void setup(void) 
{ 
  int i;
  for(i=4;i<=7;i++)
    pinMode(i, OUTPUT);  
    Voice.Initialise(MIC,VoiceRecognitionV1);//Initialise mode MIC or MONO,default is MIC
                                           //VoiceRecognitionV1 is VoiceRecognitionV1.0 shield
                                           //VoiceRecognitionV2 is VoiceRecognitionV2.1 module
  attachInterrupt(0,ExtInt0Handler,LOW); 
    Serial.begin(19200);      //Set Baud Rate
    delay(2000);//等待2秒钟播放器初始化完成
    Serial.println("\\:v 255");    // 音量设置最大  数字 0-255 数字越大音量越大
    delay(50);
} 
  
void loop()
{  
        uint8 nAsrRes;
	nAsrStatus = LD_ASR_NONE;

	while(1)
	{
		switch(nAsrStatus)
		{
			case LD_ASR_RUNING:
			case LD_ASR_ERROR:		
				break;
			case LD_ASR_NONE:
			{
				nAsrStatus=LD_ASR_RUNING;
                            if (Voice.RunASR(SUM,80,sRecog)==0)  //识别不正确
				{      
					nAsrStatus= LD_ASR_ERROR;
                                        Serial.println( "ASR_ERROR"); 
				}
                              Serial.println( "ASR_RUNING.....");
				break;
			}
			case LD_ASR_FOUNDOK:
			{
				nAsrRes =Voice. LD_GetResult();//一次ASR识别流程结束，去取ASR识别结果
                                finally(nAsrRes); 
				nAsrStatus = LD_ASR_NONE;
				break;
			}
			case LD_ASR_FOUNDZERO:
			default:
			{
				
				nAsrStatus = LD_ASR_NONE;
				break;
			}
	         }// switch
              delay(500);
	}// while
}
